Loading...
Searching...
No Matches
juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize > Class Template Reference

## Detailed Description

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
class juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >

Holds a resizable array of primitive or copy-by-value objects.

Examples of arrays are: Array<int>, Array<Rectangle> or Array<MyClass*>

The Array class can be used to hold simple, non-polymorphic objects as well as primitive types - to do so, the class must fulfill these requirements:

- it must have a copy constructor and assignment operator
- it must be able to be relocated in memory by a memcpy without this causing any problems - so objects whose functionality relies on external pointers or references to themselves can not be used.

You can of course have an array of pointers to any kind of object, e.g. Array<MyClass*>, but if you do this, the array doesn't take any ownership of the objects - see the OwnedArray class or the ReferenceCountedArray class for more powerful ways of holding lists of objects.

For holding lists of strings, you can use Array<String>, but it's usually better to use the specialised class StringArray, which provides more useful functions.

To make all the array's methods thread-safe, pass in "CriticalSection" as the templated TypeOfCriticalSectionToUse parameter, instead of the default DummyCriticalSection.

See also
  OwnedArray, ReferenceCountedArray, StringArray, CriticalSection

The documentation for this class was generated from the following file:

- juce_core/containers/juce_Array.h

## Public Types

using | ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType
| Returns the type of scoped lock to use for locking this array.

## Public Member Functions

| Array () noexcept=default
| Creates an empty array.
| Array (const Array &other)
| Creates a copy of another array.
| Array (Array &&other) noexcept
template<typename TypeToCreateFrom>
| Array (const TypeToCreateFrom *data)
| Initialises from a null-terminated raw array of values.
template<typename TypeToCreateFrom>
| Array (const TypeToCreateFrom *data, int numValues)
| Initialises from a raw array of values.
| Array (const ElementType &singleElementToAdd)
| Initialises an Array of size 1 containing a single element.
| Array (ElementType &&singleElementToAdd)
| Initialises an Array of size 1 containing a single element.
template<typename... OtherElements>
| Array (const ElementType &firstNewElement, OtherElements &&... otherElements)
| Initialises an Array from a list of items.
template<typename... OtherElements>
| Array (ElementType &&firstNewElement, OtherElements &&... otherElements)
| Initialises an Array from a list of items.
template<typename TypeToCreateFrom>
| Array (const std::initializer_list< TypeToCreateFrom > &items)
| ~Array ()=default
| Destructor.
Array & | operator= (const Array &other)
| Copies another array.
Array & | operator= (Array &&other) noexcept
template<class OtherArrayType>
bool | operator== (const OtherArrayType &other) const
| Compares this array to another one.
template<class OtherArrayType>
bool | operator!= (const OtherArrayType &other) const
| Compares this array to another one.
void | clear ()
| Removes all elements from the array.
void | clearQuick ()
| Removes all elements from the array without freeing the array's allocated storage.
void | fill (const ParameterType &newValue) noexcept
| Fills the Array with the provided value.
int | size () const noexcept
| Returns the current number of elements in the array.
bool | isEmpty () const noexcept
| Returns true if the array is empty, false otherwise.
ElementType | operator[] (int index) const
| Returns one of the elements in the array.
ElementType | getUnchecked (int index) const
| Returns one of the elements in the array, without checking the index passed in.
ElementType & | getReference (int index) noexcept
| Returns a direct reference to one of the elements in the array, without checking the index passed in.
const ElementType & | getReference (int index) const noexcept
| Returns a direct reference to one of the elements in the array, without checking the index passed in.
ElementType | getFirst () const noexcept
| Returns the first element in the array, or a default value if the array is empty.
ElementType | getLast () const noexcept
| Returns the last element in the array, or a default value if the array is empty.
ElementType * | getRawDataPointer () noexcept
| Returns a pointer to the actual array data.
const ElementType * | getRawDataPointer () const noexcept
| Returns a pointer to the actual array data.
ElementType * | begin () noexcept
| Returns a pointer to the first element in the array.
const ElementType * | begin () const noexcept
| Returns a pointer to the first element in the array.
ElementType * | end () noexcept
| Returns a pointer to the element which follows the last element in the array.
const ElementType * | end () const noexcept
| Returns a pointer to the element which follows the last element in the array.
ElementType * | data () noexcept
| Returns a pointer to the first element in the array.
const ElementType * | data () const noexcept
| Returns a pointer to the first element in the array.
int | indexOf (ParameterType elementToLookFor) const
| Finds the index of the first element which matches the value passed in.
bool | contains (ParameterType elementToLookFor) const
| Returns true if the array contains at least one occurrence of an object.
void | add (const ElementType &newElement)
| Appends a new element at the end of the array.
void | add (ElementType &&newElement)
| Appends a new element at the end of the array.
template<typename... OtherElements>
void | add (const ElementType &firstNewElement, OtherElements &&... otherElements)
| Appends multiple new elements at the end of the array.
template<typename... OtherElements>
void | add (ElementType &&firstNewElement, OtherElements &&... otherElements)
| Appends multiple new elements at the end of the array.
void | insert (int indexToInsertAt, ParameterType newElement)
| Inserts a new element into the array at a given position.
void | insertMultiple (int indexToInsertAt, ParameterType newElement, int numberOfTimesToInsertIt)
| Inserts multiple copies of an element into the array at a given position.
void | insertArray (int indexToInsertAt, const ElementType *newElements, int numberOfElements)
| Inserts an array of values into this array at a given position.
bool | addIfNotAlreadyThere (ParameterType newElement)
| Appends a new element at the end of the array as long as the array doesn't already contain it.
void | set (int indexToChange, ParameterType newValue)
| Replaces an element with a new value.
void | setUnchecked (int indexToChange, ParameterType newValue)
| Replaces an element with a new value without doing any bounds-checking.
template<typename Type>
void | addArray (const Type *elementsToAdd, int numElementsToAdd)
| Adds elements from an array to the end of this array.
template<typename TypeToCreateFrom>
void | addArray (const std::initializer_list< TypeToCreateFrom > &items)
template<typename Type>
void | addNullTerminatedArray (const Type *const *elementsToAdd)
| Adds elements from a null-terminated array of pointers to the end of this array.
template<class OtherArrayType>
void | swapWith (OtherArrayType &otherArray) noexcept
| This swaps the contents of this array with those of another array.
template<class OtherArrayType>
void | addArray (const OtherArrayType &arrayToAddFrom)
| Adds elements from another array to the end of this array.
template<class OtherArrayType>
std::enable_if_t<! std::is_pointer_v< OtherArrayType >, void > | addArray (const OtherArrayType &arrayToAddFrom, int startIndex, int numElementsToAdd=-1)
| Adds elements from another array to the end of this array.
void | resize (int targetNumItems)
| This will enlarge or shrink the array to the given number of elements, by adding or removing items from its end.
template<class ElementComparator>
int | addSorted (ElementComparator &comparator, ParameterType newElement)
| Inserts a new element into the array, assuming that the array is sorted.
void | addUsingDefaultSort (ParameterType newElement)
| Inserts a new element into the array, assuming that the array is sorted.
template<typename ElementComparator, typename TargetValueType>
int | indexOfSorted (ElementComparator &comparator, TargetValueType elementToLookFor) const
| Finds the index of an element in the array, assuming that the array is sorted.
void | remove (int indexToRemove)
| Removes an element from the array.
ElementType | removeAndReturn (int indexToRemove)
| Removes an element from the array.
void | remove (const ElementType *elementToRemove)
| Removes an element from the array.
int | removeFirstMatchingValue (ParameterType valueToRemove)
| Removes an item from the array.
int | removeAllInstancesOf (ParameterType valueToRemove)
| Removes items from the array.
template<typename PredicateType>
int | removeIf (PredicateType &&predicate)
| Removes items from the array.
void | removeRange (int startIndex, int numberToRemove)
| Removes a range of elements from the array.
void | removeLast (int howManyToRemove=1)
| Removes the last n elements from the array.
template<class OtherArrayType>
void | removeValuesIn (const OtherArrayType &otherArray)
| Removes any elements which are also in another array.
template<class OtherArrayType>
void | removeValuesNotIn (const OtherArrayType &otherArray)
| Removes any elements which are not found in another array.
void | swap (int index1, int index2)
| Swaps over two elements in the array.
void | move (int currentIndex, int newIndex) noexcept
| Moves one of the values to a different position.
void | minimiseStorageOverheads ()
| Reduces the amount of storage being used by the array.
void | ensureStorageAllocated (int minNumElements)
| Increases the array's internal storage to hold a minimum number of elements.
void | sort ()
| Sorts the array using a default comparison operation.
template<class ElementComparator>
void | sort (ElementComparator &comparator, bool retainOrderOfEquivalentItems=false)
| Sorts the elements in the array.
const TypeOfCriticalSectionToUse & | getLock () const noexcept
| Returns the CriticalSection that locks this array.

## Member Typedef Documentation

## ScopedLockType

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

using juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

Returns the type of scoped lock to use for locking this array.

## Constructors and Destructors

## Array() [1/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( |  | ) |

default noexcept

Creates an empty array.

## Array() [2/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | const Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize > & | other | ) |

inline

Creates a copy of another array.

Parameters

  other | the array to copy

## Array() [3/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize > && | other | ) |

inline noexcept

## Array() [4/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename TypeToCreateFrom>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | const TypeToCreateFrom * | data | ) |

inline explicit

Initialises from a null-terminated raw array of values.

Parameters

  data | the data to copy from

## Array() [5/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename TypeToCreateFrom>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | const TypeToCreateFrom * | data,
|  | int | numValues )

inline

Initialises from a raw array of values.

Parameters

  data | the data to copy from
  numValues | the number of values in the array

## Array() [6/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | const ElementType & | singleElementToAdd | ) |

inline

Initialises an Array of size 1 containing a single element.

## Array() [7/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | ElementType && | singleElementToAdd | ) |

inline

Initialises an Array of size 1 containing a single element.

## Array() [8/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename... OtherElements>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | const ElementType & | firstNewElement,
|  | OtherElements &&... | otherElements )

inline

Initialises an Array from a list of items.

## Array() [9/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename... OtherElements>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | ElementType && | firstNewElement,
|  | OtherElements &&... | otherElements )

inline

Initialises an Array from a list of items.

## Array() [10/10]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename TypeToCreateFrom>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::Array | ( | const std::initializer_list< TypeToCreateFrom > & | items | ) |

inline

## ~Array()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::~Array | ( |  | ) |

default

Destructor.

## Member Functions

## operator=() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

Array & juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::operator= | ( | const Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize > & | other | ) |

inline

Copies another array.

Parameters

  other | the array to copy

## operator=() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

Array & juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::operator= | ( | Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize > && | other | ) |

inline noexcept

## operator==()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class OtherArrayType>

bool juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::operator== | ( | const OtherArrayType & | other | ) | const

inline

Compares this array to another one.

Two arrays are considered equal if they both contain the same set of elements, in the same order.

Parameters

  other | the other array to compare with

Referenced by juce::Array< SelectableItemType >::operator!=().

## operator!=()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class OtherArrayType>

bool juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::operator!= | ( | const OtherArrayType & | other | ) | const

inline

Compares this array to another one.

Two arrays are considered equal if they both contain the same set of elements, in the same order.

Parameters

  other | the other array to compare with

## clear()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::clear | ( |  | ) |

inline

Removes all elements from the array.

This will remove all the elements, and free any storage that the array is using. To clear the array without freeing the storage, use the clearQuick() method instead.

See also
  clearQuick

Referenced by juce::Array< SelectableItemType >::removeValuesIn(), and juce::Array< SelectableItemType >::removeValuesNotIn().

## clearQuick()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::clearQuick | ( |  | ) |

inline

Removes all elements from the array without freeing the array's allocated storage.

See also
  clear

Referenced by juce::Array< SelectableItemType >::clear(), and juce::dsp::Polynomial< FloatingType >::getProductWith().

## fill()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::fill | ( | const ParameterType & | newValue | ) |

inline noexcept

Fills the Array with the provided value.

## size()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

int juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::size | ( |  | ) | const

inline noexcept

Returns the current number of elements in the array.

Referenced by juce::dsp::Polynomial< FloatingType >::getProductWith(), juce::dsp::Polynomial< FloatingType >::getSumWith(), juce::Array< SelectableItemType >::isEmpty(), sort(), and juce::RectangleList< ValueType >::subtract().

## isEmpty()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

bool juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::isEmpty | ( |  | ) | const

inline noexcept

Returns true if the array is empty, false otherwise.

## operator[]()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::operator[] | ( | int | index | ) | const

inline

Returns one of the elements in the array.

If the index passed in is beyond the range of valid elements, this will return a default value.

If you're certain that the index will always be a valid element, you can call getUnchecked() instead, which is faster.

Parameters

  index | the index of the element being requested (0 is the first element in the array)

See also
  getUnchecked, getFirst, getLast

## getUnchecked()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getUnchecked | ( | int | index | ) | const

inline

Returns one of the elements in the array, without checking the index passed in.

Unlike the operator[] method, this will try to return an element without checking that the index is within the bounds of the array, so should only be used when you're confident that it will always be a valid index.

Parameters

  index | the index of the element being requested (0 is the first element in the array)

See also
  operator[], getFirst, getLast

Referenced by juce::HashMap< KeyType, ValueType, HashFunctionType, TypeOfCriticalSectionToUse >::remapTable().

## getReference() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType & juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getReference | ( | int | index | ) |

inline noexcept

Returns a direct reference to one of the elements in the array, without checking the index passed in.

This is like getUnchecked, but returns a direct reference to the element, so that you can alter it directly. Obviously this can be dangerous, so only use it when absolutely necessary.

Parameters

  index | the index of the element being requested (0 is the first element in the array)

See also
  operator[], getFirst, getLast

## getReference() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

const ElementType & juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getReference | ( | int | index | ) | const

inline noexcept

Returns a direct reference to one of the elements in the array, without checking the index passed in.

This is like getUnchecked, but returns a direct reference to the element. Obviously this can be dangerous, so only use it when absolutely necessary.

Parameters

  index | the index of the element being requested (0 is the first element in the array)

See also
  operator[], getFirst, getLast

## getFirst()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getFirst | ( |  | ) | const

inline noexcept

Returns the first element in the array, or a default value if the array is empty.

See also
  operator[], getUnchecked, getLast

## getLast()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getLast | ( |  | ) | const

inline noexcept

Returns the last element in the array, or a default value if the array is empty.

See also
  operator[], getUnchecked, getFirst

## getRawDataPointer() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getRawDataPointer | ( |  | ) |

inline noexcept

Returns a pointer to the actual array data.

This pointer will only be valid until the next time a non-const method is called on the array.

## getRawDataPointer() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

const ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getRawDataPointer | ( |  | ) | const

inline noexcept

Returns a pointer to the actual array data.

This pointer will only be valid until the next time a non-const method is called on the array.

## begin() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::begin | ( |  | ) |

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

Referenced by juce::Array< SelectableItemType >::data(), juce::Array< SelectableItemType >::data(), and juce::RectangleList< ValueType >::subtract().

## begin() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

const ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::begin | ( |  | ) | const

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## end() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::end | ( |  | ) |

inline noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

Referenced by juce::RectangleList< ValueType >::subtract().

## end() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

const ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::end | ( |  | ) | const

inline noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## data() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::data | ( |  | ) |

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

## data() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

const ElementType * juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::data | ( |  | ) | const

inline noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

## indexOf()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

int juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::indexOf | ( | ParameterType | elementToLookFor | ) | const

inline

Finds the index of the first element which matches the value passed in.

This will search the array for the given object, and return the index of its first occurrence. If the object isn't found, the method will return -1.

Parameters

  elementToLookFor | the value or object to look for

Returns
  the index of the object, or -1 if it's not found

## contains()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

bool juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::contains | ( | ParameterType | elementToLookFor | ) | const

inline

Returns true if the array contains at least one occurrence of an object.

Parameters

  elementToLookFor | the value or object to look for

Returns
  true if the item is found

## add() [1/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::add | ( | const ElementType & | newElement | ) |

inline

Appends a new element at the end of the array.

Parameters

  newElement | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addUsingDefaultSort, addArray

Referenced by juce::Array< SelectableItemType >::addIfNotAlreadyThere(), juce::Array< SelectableItemType >::Array(), juce::Array< SelectableItemType >::Array(), juce::Array< SelectableItemType >::Array(), and juce::dsp::Polynomial< FloatingType >::getProductWith().

## add() [2/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::add | ( | ElementType && | newElement | ) |

inline

Appends a new element at the end of the array.

Parameters

  newElement | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addUsingDefaultSort, addArray

## add() [3/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename... OtherElements>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::add | ( | const ElementType & | firstNewElement,
|  | OtherElements &&... | otherElements )

inline

Appends multiple new elements at the end of the array.

## add() [4/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename... OtherElements>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::add | ( | ElementType && | firstNewElement,
|  | OtherElements &&... | otherElements )

inline

Appends multiple new elements at the end of the array.

## insert()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::insert | ( | int | indexToInsertAt,
|  | ParameterType | newElement )

inline

Inserts a new element into the array at a given position.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

Parameters

  indexToInsertAt | the index at which the new element should be inserted (pass in -1 to add it to the end)
  newElement | the new object to add to the array

See also
  add, addSorted, addUsingDefaultSort, set

Referenced by juce::Array< SelectableItemType >::addSorted().

## insertMultiple()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::insertMultiple | ( | int | indexToInsertAt,
|  | ParameterType | newElement,
|  | int | numberOfTimesToInsertIt )

inline

Inserts multiple copies of an element into the array at a given position.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newElement | the new object to add to the array
  numberOfTimesToInsertIt | how many copies of the value to insert

See also
  insert, add, addSorted, set

Referenced by juce::HashMap< KeyType, ValueType, HashFunctionType, TypeOfCriticalSectionToUse >::remapTable(), and juce::Array< SelectableItemType >::resize().

## insertArray()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::insertArray | ( | int | indexToInsertAt,
|  | const ElementType * | newElements,
|  | int | numberOfElements )

inline

Inserts an array of values into this array at a given position.

If the index is less than 0 or greater than the size of the array, the new elements will be added to the end of the array. Otherwise, they will be inserted into the array, moving all the later elements along to make room.

Parameters

  indexToInsertAt | the index at which the first new element should be inserted
  newElements | the new values to add to the array
  numberOfElements | how many items are in the array

See also
  insert, add, addSorted, set

## addIfNotAlreadyThere()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

bool juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addIfNotAlreadyThere | ( | ParameterType | newElement | ) |

inline

Appends a new element at the end of the array as long as the array doesn't already contain it.

If the array already contains an element that matches the one passed in, nothing will be done.

Parameters

  newElement | the new object to add to the array

Returns
  true if the element was added to the array; false otherwise.

## set()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::set | ( | int | indexToChange,
|  | ParameterType | newValue )

inline

Replaces an element with a new value.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the item is added to the end of the array.

Parameters

  indexToChange | the index whose value you want to change
  newValue | the new value to set for this index.

See also
  add, insert

Referenced by juce::HashMap< KeyType, ValueType, HashFunctionType, TypeOfCriticalSectionToUse >::remapTable().

## setUnchecked()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::setUnchecked | ( | int | indexToChange,
|  | ParameterType | newValue )

inline

Replaces an element with a new value without doing any bounds-checking.

This just sets a value directly in the array's internal storage, so you'd better make sure it's in range!

Parameters

  indexToChange | the index whose value you want to change
  newValue | the new value to set for this index.

See also
  set, getUnchecked

## addArray() [1/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename Type>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addArray | ( | const Type * | elementsToAdd,
|  | int | numElementsToAdd )

inline

Adds elements from an array to the end of this array.

Parameters

  elementsToAdd | an array of some kind of object from which elements can be constructed.
  numElementsToAdd | how many elements are in this other array

See also
  add

Referenced by juce::Array< SelectableItemType >::addNullTerminatedArray(), juce::Array< SelectableItemType >::Array(), juce::LassoComponent< SelectableItemType >::dragLasso(), juce::OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange(), and juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange().

## addArray() [2/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename TypeToCreateFrom>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addArray | ( | const std::initializer_list< TypeToCreateFrom > & | items | ) |

inline

## addNullTerminatedArray()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename Type>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addNullTerminatedArray | ( | const Type *const * | elementsToAdd | ) |

inline

Adds elements from a null-terminated array of pointers to the end of this array.

Parameters

  elementsToAdd | an array of pointers to some kind of object from which elements can be constructed. This array must be terminated by a nullptr

See also
  addArray

## swapWith()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class OtherArrayType>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::swapWith | ( | OtherArrayType & | otherArray | ) |

inline noexcept

This swaps the contents of this array with those of another array.

If you need to exchange two arrays, this is vastly quicker than using copy-by-value because it just swaps their internal pointers.

Referenced by juce::Array< SelectableItemType >::operator=().

## addArray() [3/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class OtherArrayType>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addArray | ( | const OtherArrayType & | arrayToAddFrom | ) |

inline

Adds elements from another array to the end of this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements

See also
  add

## addArray() [4/4]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class OtherArrayType>

std::enable_if_t<! std::is_pointer_v< OtherArrayType >, void > juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addArray | ( | const OtherArrayType & | arrayToAddFrom,
|  | int | startIndex,
|  | int | numElementsToAdd = -1 )

inline

Adds elements from another array to the end of this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

## resize()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::resize | ( | int | targetNumItems | ) |

inline

This will enlarge or shrink the array to the given number of elements, by adding or removing items from its end.

If the array is smaller than the given target size, empty elements will be appended until its size is as specified. If its size is larger than the target, items will be removed from its end to shorten it.

Referenced by juce::RectangleList< ValueType >::subtract().

## addSorted()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class ElementComparator>

int juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addSorted | ( | ElementComparator & | comparator,
|  | ParameterType | newElement )

inline

Inserts a new element into the array, assuming that the array is sorted.

This will use a comparator to find the position at which the new element should go. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator to use to compare the elements - see the sort() method for details about the form this object should take
  newElement | the new element to insert to the array

Returns
  the index at which the new item was added

See also
  addUsingDefaultSort, add, sort

Referenced by juce::Array< SelectableItemType >::addUsingDefaultSort().

## addUsingDefaultSort()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addUsingDefaultSort | ( | ParameterType | newElement | ) |

inline

Inserts a new element into the array, assuming that the array is sorted.

This will use the DefaultElementComparator class for sorting, so your ElementType must be suitable for use with that class. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  newElement | the new element to insert to the array

See also
  addSorted, sort

## indexOfSorted()

template<typename ElementType, typename TypeOfCriticalSectionToUse, int minimumAllocatedSize>
template<typename ElementComparator, typename TargetValueType>

int juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::indexOfSorted | ( | ElementComparator & | comparator,
|  | TargetValueType | elementToLookFor ) const

Finds the index of an element in the array, assuming that the array is sorted.

This will use a comparator to do a binary-chop to find the index of the given element, if it exists. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator to use to compare the elements - see the sort() method for details about the form this object should take
  elementToLookFor | the element to search for

Returns
  the index of the element, or -1 if it's not found

See also
  addSorted, sort

References getLock().

## remove() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::remove | ( | int | indexToRemove | ) |

inline

Removes an element from the array.

This will remove the element at a given index, and move back all the subsequent elements to close the gap. If the index passed in is out-of-range, nothing will happen.

Parameters

  indexToRemove | the index of the element to remove

See also
  removeAndReturn, removeFirstMatchingValue, removeAllInstancesOf, removeRange

## removeAndReturn()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

ElementType juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeAndReturn | ( | int | indexToRemove | ) |

inline

Removes an element from the array.

This will remove the element at a given index, and move back all the subsequent elements to close the gap. If the index passed in is out-of-range, nothing will happen.

Parameters

  indexToRemove | the index of the element to remove

Returns
  the element that has been removed

See also
  removeFirstMatchingValue, removeAllInstancesOf, removeRange

## remove() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::remove | ( | const ElementType * | elementToRemove | ) |

inline

Removes an element from the array.

This will remove the element pointed to by the given iterator, and move back all the subsequent elements to close the gap. If the iterator passed in does not point to an element within the array, behaviour is undefined.

Parameters

  elementToRemove | a pointer to the element to remove

See also
  removeFirstMatchingValue, removeAllInstancesOf, removeRange, removeIf

## removeFirstMatchingValue()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

int juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeFirstMatchingValue | ( | ParameterType | valueToRemove | ) |

inline

Removes an item from the array.

This will remove the first occurrence of the given element from the array. If the item isn't found, no action is taken.

Parameters

  valueToRemove | the object to try to remove

Returns
  the index of the removed item, or -1 if the item isn't found

See also
  remove, removeRange, removeIf

## removeAllInstancesOf()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

int juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeAllInstancesOf | ( | ParameterType | valueToRemove | ) |

inline

Removes items from the array.

This will remove all occurrences of the given element from the array. If no such items are found, no action is taken.

Parameters

  valueToRemove | the object to try to remove

Returns
  how many objects were removed.

See also
  remove, removeRange, removeIf

## removeIf()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<typename PredicateType>

int juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeIf | ( | PredicateType && | predicate | ) |

inline

Removes items from the array.

This will remove all objects from the array that match a condition. If no such items are found, no action is taken.

Parameters

  predicate | the condition when to remove an item. Must be a callable type that takes an ElementType and returns a bool

Returns
  how many objects were removed.

See also
  remove, removeRange, removeAllInstancesOf

## removeRange()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeRange | ( | int | startIndex,
|  | int | numberToRemove )

inline

Removes a range of elements from the array.

This will remove a set of elements, starting from the given index, and move subsequent elements down to close the gap.

If the range extends beyond the bounds of the array, it will be safely clipped to the size of the array.

Parameters

  startIndex | the index of the first element to remove
  numberToRemove | how many elements should be removed

See also
  remove, removeFirstMatchingValue, removeAllInstancesOf, removeIf

Referenced by juce::Array< SelectableItemType >::resize().

## removeLast()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeLast | ( | int | howManyToRemove = 1 | ) |

inline

Removes the last n elements from the array.

Parameters

  howManyToRemove | how many elements to remove from the end of the array

See also
  remove, removeFirstMatchingValue, removeAllInstancesOf, removeRange

## removeValuesIn()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class OtherArrayType>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeValuesIn | ( | const OtherArrayType & | otherArray | ) |

inline

Removes any elements which are also in another array.

Parameters

  otherArray | the other array in which to look for elements to remove

See also
  removeValuesNotIn, remove, removeFirstMatchingValue, removeAllInstancesOf, removeRange

Referenced by juce::LassoComponent< SelectableItemType >::dragLasso().

## removeValuesNotIn()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>
template<class OtherArrayType>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::removeValuesNotIn | ( | const OtherArrayType & | otherArray | ) |

inline

Removes any elements which are not found in another array.

Only elements which occur in this other array will be retained.

Parameters

  otherArray | the array in which to look for elements NOT to remove

See also
  removeValuesIn, remove, removeFirstMatchingValue, removeAllInstancesOf, removeRange

## swap()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::swap | ( | int | index1,
|  | int | index2 )

inline

Swaps over two elements in the array.

This swaps over the elements found at the two indexes passed in. If either index is out-of-range, this method will do nothing.

Parameters

  index1 | index of one of the elements to swap
  index2 | index of the other element to swap

## move()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::move | ( | int | currentIndex,
|  | int | newIndex )

inline noexcept

Moves one of the values to a different position.

This will move the value to a specified index, shuffling along any intervening elements as required.

So for example, if you have the array { 0, 1, 2, 3, 4, 5 } then calling move (2, 4) would result in { 0, 1, 3, 4, 2, 5 }.

Parameters

  currentIndex | the index of the value to be moved. If this isn't a valid index, then nothing will be done
  newIndex | the index at which you'd like this value to end up. If this is less than zero, the value will be moved to the end of the array

## minimiseStorageOverheads()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::minimiseStorageOverheads | ( |  | ) |

inline

Reduces the amount of storage being used by the array.

Arrays typically allocate slightly more storage than they need, and after removing elements, they may have quite a lot of unused space allocated. This method will reduce the amount of allocated storage to a minimum.

## ensureStorageAllocated()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::ensureStorageAllocated | ( | int | minNumElements | ) |

inline

Increases the array's internal storage to hold a minimum number of elements.

Calling this before adding a large known number of elements means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

## sort() [1/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::sort | ( |  | ) |

inline

Sorts the array using a default comparison operation.

If the type of your elements isn't supported by the DefaultElementComparator class then you may need to use the other version of sort, which takes a custom comparator.

Referenced by juce::Array< SelectableItemType >::sort().

## sort() [2/2]

template<typename ElementType, typename TypeOfCriticalSectionToUse, int minimumAllocatedSize>
template<class ElementComparator>

void juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::sort | ( | ElementComparator & | comparator,
|  | bool | retainOrderOfEquivalentItems = false )

Sorts the elements in the array.

This will use a comparator object to sort the elements into order. The object passed must have a method of the form:

int compareElements (ElementType first, ElementType second);

...and this method must return:

- a value of < 0 if the first comes before the second
- a value of 0 if the two objects are equivalent
- a value of > 0 if the second comes before the first

To improve performance, the compareElements() method can be declared as static or const.

Parameters

  comparator | the comparator to use for comparing elements.
  retainOrderOfEquivalentItems | if this is true, then items which the comparator says are equivalent will be kept in the order in which they currently appear in the array. This is slower to perform, but may be important in some cases. If it's false, a faster algorithm is used, but equivalent elements may be rearranged.

See also
  addSorted, indexOfSorted, sortArray

References getLock(), size(), and juce::sortArray().

## getLock()

template<typename ElementType, typename TypeOfCriticalSectionToUse = DummyCriticalSection, int minimumAllocatedSize = 0>

const TypeOfCriticalSectionToUse & juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::getLock | ( |  | ) | const

inline noexcept

Returns the CriticalSection that locks this array.

To lock, you can call getLock().enter() and getLock().exit(), or preferably use an object of ScopedLockType as an RAII lock for it.

Referenced by juce::Array< SelectableItemType >::add(), juce::Array< SelectableItemType >::add(), juce::Array< SelectableItemType >::add(), juce::Array< SelectableItemType >::add(), juce::Array< SelectableItemType >::addArray(), juce::Array< SelectableItemType >::addArray(), juce::Array< SelectableItemType >::addArray(), juce::Array< SelectableItemType >::addArray(), juce::Array< SelectableItemType >::addIfNotAlreadyThere(), juce::Array< SelectableItemType >::addSorted(), juce::Array< SelectableItemType >::clear(), juce::Array< SelectableItemType >::clearQuick(), juce::Array< SelectableItemType >::contains(), juce::Array< SelectableItemType >::ensureStorageAllocated(), juce::Array< SelectableItemType >::fill(), juce::Array< SelectableItemType >::getFirst(), juce::Array< SelectableItemType >::getLast(), juce::Array< SelectableItemType >::getReference(), juce::Array< SelectableItemType >::getReference(), juce::Array< SelectableItemType >::getUnchecked(), juce::Array< SelectableItemType >::indexOf(), indexOfSorted(), juce::Array< SelectableItemType >::insert(), juce::Array< SelectableItemType >::insertArray(), juce::Array< SelectableItemType >::insertMultiple(), juce::Array< SelectableItemType >::minimiseStorageOverheads(), juce::Array< SelectableItemType >::move(), juce::Array< SelectableItemType >::operator=(), juce::Array< SelectableItemType >::operator==(), juce::Array< SelectableItemType >::operator[](), juce::Array< SelectableItemType >::remove(), juce::Array< SelectableItemType >::remove(), juce::Array< SelectableItemType >::removeAllInstancesOf(), juce::Array< SelectableItemType >::removeAndReturn(), juce::Array< SelectableItemType >::removeFirstMatchingValue(), juce::Array< SelectableItemType >::removeIf(), juce::Array< SelectableItemType >::removeLast(), juce::Array< SelectableItemType >::removeRange(), juce::Array< SelectableItemType >::removeValuesIn(), juce::Array< SelectableItemType >::removeValuesNotIn(), juce::Array< SelectableItemType >::set(), juce::Array< SelectableItemType >::setUnchecked(), juce::Array< SelectableItemType >::size(), sort(), juce::Array< SelectableItemType >::swap(), and juce::Array< SelectableItemType >::swapWith().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited